//
//  CGOLDocument.swift
//  ConwaysGameOfLife
//
//  Created by narita on 2018/08/21.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class CGOLDocument: NSDocument
{
    // MARK: - class methods
    
    override class var autosavesInPlace: Bool
    {
        return true
    }

    // MARK: - init methods
    
    override init()
    {
        self.model = CGOLModel()
        
        super.init()
        
        // ここでテストコードを試す。
        //self.testCode()
    }

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    override func data(ofType typeName: String) throws -> Data
    {
        return try self.model.writeToData()
    }
    
    override func read(from data: Data, ofType typeName: String) throws
    {
        try self.model.read(from: data)
    }
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    // MARK: - action methods

    @IBAction func clearAll(_ sender: Any?)
    {
        self.model.clearAll()
    }
    
    @IBAction func start(_ sender: Any?)
    {
        self.model.start()
    }

    @IBAction func stop(_ sender: Any?)
    {
        self.model.stop()
    }

    @IBAction func next(_ sender: Any?)
    {
        self.model.next()
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    var model: CGOLModel
    
    // MARK: - Utility methods

    override func makeWindowControllers()
    {
        // Returns the Storyboard that contains your Document window.
        let storyboard = NSStoryboard(name: NSStoryboard.Name("Main"), bundle: nil)
        let windowController = storyboard.instantiateController(withIdentifier: NSStoryboard.SceneIdentifier("Document Window Controller")) as! NSWindowController
        self.addWindowController(windowController)
        
        self.windowControllers.forEach()
        {
            i in
            
            if let theViewController = i.contentViewController as! CGOLViewController?
            {
                // ドキュメントを設定
                theViewController.representedObject = self.model
            }
        }
    }
    
    // テストコード。UnitTestにした方がよかった。onz
    func testCode()
    {
        self.model.cellsSize = CGOLSize(width: 32, height: 32)
        
        let theMap =
            "................................\r" +
            "...OOO..............O...........\r" + // ブリンカー
            "....................OO..........\r" + // ブロック
            "...........OOOO.................\r" + // 蜂の巣
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            ".............OOO................\r" +  // Tテトロミノ
            "..............O.................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "...O............................\r" + // グライダー
            "....O...........................\r" +
            "..OOO...........................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r" +
            "................................\r"
        
        self.model.gameBoardSetup(newLifeGameBoard: theMap as NSString)
    }
}

